#Copyright (C) Seiko Epson Corporation 2017.
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU Lesser General Public
#License as published by the Free Software Foundation; either
#version 2.1 of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#Lesser General Public License for more details.
#
#You should have received a copy of the GNU Lesser General Public
#License along with this program; if not, write to the Free  Software Foundation, Inc., 
#51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

%define packagename     epson-printer-utility
%define pkgver    		1.1.1

# used in RPM macro set for the LSB Driver Development Kit
%define utility_name	epson-printer-utility
%define utility_ver		1.1.1
%define backend_name	epson-backend	
%define backend_ver		1.1.1

%define lsbver          3.2
%define rel     		1
%define extraversion    -%{rel}lsb%{lsbver}

%define supplier		%{packagename}
%define supplierstr     Seiko Epson Corporation


AutoReqProv: no

Name: %{packagename}
Version: %{pkgver}
Release: %{rel}lsb%{lsbver}
Source0: %{name}-%{utility_ver}.tar.gz
Source1: %{backend_name}-%{backend_ver}.tar.gz
License: LGPL
Vendor: %{supplierstr}
URL: http://download.ebz.epson.net/dsc/search/01/search/?OSC=LX
Packager: Seiko Epson Corporation <linux-printer@epson.jp>
BuildRoot: %{_tmppath}/%{packagename}-%{pkgver}-%{release}
Group: Applications/System
Requires: lsb >= %{lsbver}
Summary: Epson Printer Utility for Linux

%description
This is a Printer Utility program for Epson Printer Driver.  
Using this software, you can check ink levels, view error and other status... on EPSON Printers. 
For detail list of supported printer, please refer to below site:
http://download.ebz.epson.net/dsc/search/01/search/?OSC=LX
# Packaging settings
%install_into_opt

# Packaging settings
%prep
rm -rf $RPM_BUILD_DIR/%{packagename}-%{pkgver}
tar xzvf %{_sourcedir}/%{utility_name}-%{utility_ver}.tar.gz -C $RPM_BUILD_DIR/
tar xzvf %{_sourcedir}/%{backend_name}-%{backend_ver}.tar.gz -C $RPM_BUILD_DIR/

%build
# utility
cd %{utility_name}-%{utility_ver}
autoreconf -vfi
%configure
%make

# backend
cd ../%{backend_name}-%{backend_ver}
autoreconf -vfi
%configure
%make

%install
# rm -rf %{buildroot}
# Make directories
# utility
echo %{_prefix}/*
cd %{packagename}-%{pkgver}
ls
# install -d %{buildroot}%{_libdir}
make install-strip DESTDIR=${RPM_BUILD_ROOT}

rules_dir=/etc/udev/rules.d

install -d %{buildroot}%{_docdir}
install -m 755 README AUTHORS NEWS INSTALL ChangeLog %{buildroot}%{_docdir}

cd PrinterUtility
install -d %{buildroot}%{_prefix}/bin
install -m 0777 %{utility_name} %{buildroot}%{_prefix}/bin

install -d %{buildroot}%{_prefix}/resource
cp -R Images %{buildroot}%{_prefix}/resource
cd ..
cd EPSCommonLib
install -d %{buildroot}%{_prefix}/lib
install -m 0755 libEPSCommonLib.a %{buildroot}%{_prefix}/lib
cd ..
cd support-tool
install -d %{buildroot}%{_prefix}/rules
install -m 0755 79-udev-epson.rules %{buildroot}%{_prefix}/rules
cd ..

# backend
cd ../%{backend_name}-%{backend_ver}
install -d %{buildroot}/usr/lib/cups/backend
install -m 755 src/ecblp %{buildroot}/usr/lib/cups/backend/ecblp

install -d %{buildroot}/usr/lib/%{backend_name}
install -m 755 daemon/ecbd %{buildroot}/usr/lib/%{backend_name}/ecbd

install -d %{buildroot}/usr/lib/%{backend_name}/rc.d/
install -m 755 daemon/rc/ecbd           %{buildroot}/usr/lib/%{backend_name}/rc.d/ecbd
install -m 755 daemon/rc/init-functions %{buildroot}/usr/lib/%{backend_name}/rc.d/init-functions
install -m 755 daemon/rc/inst-rc_d.sh   %{buildroot}/usr/lib/%{backend_name}/rc.d/inst-rc_d.sh

install -d %{buildroot}/usr/lib/%{backend_name}/scripts/
install -m 755 setup/inst-cups-post.sh %{buildroot}/usr/lib/%{backend_name}/scripts/inst-cups-post.sh

%pre
%create_opt_dirs

%post
/sbin/ldconfig
# utility
ln -s /opt/%{packagename}/bin/%{utility_name} /usr/bin/%{utility_name}
install -m 0755 %{_prefix}/rules/79-udev-epson.rules /etc/udev/rules.d
# backend
cd /usr/lib/%{backend_name}/scripts/
./inst-cups-post.sh install

%preun
if [ "$1" = 0 ] ; then
	 cd /usr/lib/%{backend_name}/scripts/
        ./inst-cups-post.sh deinstall
fi


%postun
/sbin/ldconfig
rm -f /usr/bin/%{utility_name}
rm -f /etc/udev/rules.d/79-udev-epson.rules
rm -f /opt/epson-printer-utility/lib/*
rm -f /usr/lib/%{backend_name}/setup

%clean
cd $RPM_BUILD_DIR/%{packagename}-%{pkgver}
make clean
# rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_prefix}/*
/usr/lib/cups/backend/ecblp
/usr/lib/%{backend_name}/ecbd
/usr/lib/%{backend_name}/rc.d/ecbd
/usr/lib/%{backend_name}/rc.d/init-functions
/usr/lib/%{backend_name}/rc.d/inst-rc_d.sh
/usr/lib/%{backend_name}/scripts/inst-cups-post.sh

